#include "Engine.h"

void load3ds(char * name)
{
    objs_header = true;
	int i = 0, w;
	FILE *file;
	bool eof = false;
	
	unsigned short chunk_id;
	unsigned int chunk_lenght;
 
	unsigned char chr;
	unsigned short qty;
	char s[1000];
	unsigned short face_flags;

	    if((file = fopen(name, "rb")) == NULL)
        {
            printf("could not find one or more of the object\n");
            return;
        }
        
	    while (eof == false)
	    {
	        if (fread (&chunk_id, 2, 1, file) != 1) eof = true;
	        if (fread (&chunk_lenght, 4, 1, file) != 1) eof = true;

		    switch (chunk_id)
            {
		    	case 0x4d4d: 
		    	break;
		    	case 0x3d3d:
		    	break;
		    	case 0x4000: 
		    		i=0;
		    		do
                    {
					    if (fread (&chr, 1, 1, file) != 1) eof = true;
                        object.name[i] = chr;
					    i++;
                    }while(chr != '\0' && i<20);
			    break;
			    case 0x4100:
			    break;
			    case 0x4110: 
			    	if (fread (&qty, sizeof (unsigned short), 1, file) != 1) eof = true;
			    	object.vert_num = qty;
			    	
                    for (i = 0; i<qty; i++)
                    {
					    if (fread (&object.vertex[i].x, sizeof(float), 1, file) != 1) eof = true;
                        if (fread (&object.vertex[i].y, sizeof(float), 1, file) != 1) eof = true;
					    if (fread (&object.vertex[i].z, sizeof(float), 1, file) != 1) eof = true;
				    }
				    break;
			    case 0x4120:
				    if (fread (&qty, sizeof (unsigned short), 1, file) != 1) eof = true;
				    object.poly_num = qty; 
                    for (i=0; i<qty; i++)
                    {
				    	if (fread (&object.triangle[i].a, sizeof (unsigned short), 1, file) != 1) eof = true;
				    	if (fread (&object.triangle[i].b, sizeof (unsigned short), 1, file) != 1) eof = true;
				    	if (fread (&object.triangle[i].c, sizeof (unsigned short), 1, file) != 1) eof = true;
				    	if (fread (&face_flags, sizeof (unsigned short), 1, file) != 1) eof = true;
				    }
                    break; 
			    case 0x4140:
				    if (fread (&qty, sizeof (unsigned short), 1, file)!= 1) eof = true;
				    for (i=0; i<qty; i++)
				    {
				    	if (fread (&object.texcoord[i].u, sizeof (float), 1, file) != 1) eof = true;
                        if (fread (&object.texcoord[i].v, sizeof (float), 1, file) != 1) eof = true;
		            }
                    break;
			    default:
				    fseek(file, chunk_lenght-6, SEEK_CUR);
            } 
	    }
	    fclose (file);
}

void loadobj(char * name)
{
    objs_header = true;
    FILE * file;
    char line[255];
    object.poly_num = 0;
    char * data;
    float temp[2];
    unsigned int vertc = 0;
    int aw = 1, q, ty = 0;

    file = fopen(name, "rt");
    while (fgets(line,100,file) != NULL)
    {
    if (line[0] == 'v' && line[1] == ' ')			
    {
        data = strtok(line, " ");
        for (int i = 0; i < 3; i++)
        {
            data = strtok(NULL, " ");
            temp[i] = (float)atof(data);
        }
        object.vertex[vertc].x = temp[0];
        object.vertex[vertc].y = temp[1];
        object.vertex[vertc].z = temp[2];
        vertc++;
    }
    else if (line[0] == 'f' && line[1] == ' ')
    {
        object.poly_num = object.poly_num + 1;
        data = strtok(line," ");
        while ((data = strtok(NULL," ")) != NULL)
        {
            object.vert_num = object.vert_num + 1;
            if (q == 1)
                object.triangle[ty].a = (int)strtol(data, NULL, 10);
            else if (q == 2)
                object.triangle[ty].b = (int)strtol(data, NULL, 10);
            else if (q == 3)
                object.triangle[ty].c = (int)strtol(data, NULL, 10);
            else 
                q = 1;
            q++;
        }
    }
    }
    fclose(file);
}

void loadmd2(char *name)
{
      objs_header = false;
      FILE *file = fopen(name, "rb");
      fread(&Md21, sizeof(Md2Header), 1, file);

      Skinsp = (ASkin *) malloc(sizeof(ASkin) * Md21.numSkins);
      TexCoordsp = (ATexCoord *) malloc(sizeof(ATexCoord) * Md21.numTexCoords);
      Trianglesp = (ATriangle *) malloc(sizeof(ATriangle) * Md21.numTriangles);
      Framesp = (AFrame *) malloc(sizeof(AFrame) * Md21.numFrames);
      
      fseek(file, Md21.offsetSkins, SEEK_SET);
      fread(Skinsp, sizeof(ASkin), Md21.numSkins, file);

      fseek(file, Md21.offsetTexCoords, SEEK_SET);
      fread(TexCoordsp, sizeof(ATexCoord), Md21.numTexCoords, file);

      fseek(file, Md21.offsetTriangles, SEEK_SET);
      fread(Trianglesp, sizeof(ATriangle), Md21.numTriangles, file);
      
      fseek(file, Md21.offsetFrames, SEEK_SET);
      fread(AFrame, 1, Md21.frameSize, file);
      
      Framesp[0].Vertsp = (AVertice *) malloc(sizeof(AVertice) * Md21.numVertices);

      for(int i = 0; i < Md21.numVertices; i++)
      {
            AVert tempVert;
            tempVert.vertex[1] = Framesp[0].Vertsp[i].vertex[1];
            tempVert.vertex[2] = Framesp[0].Vertsp[i].vertex[2];
            Framesp[0].Vertsp[i].vertex[1] = tempVert.vertex[2];
            Framesp[0].Vertsp[i].vertex[2] = tempVert.vertex[1];
      }

      for (int j = 0; j < Md21.numTexCoords; j++)
      {
            TexCoordsp[j].u = TexCoordsp[j].u / float(Md21.skinWidth);
            TexCoordsp[j].v = TexCoordsp[j].v / float(Md21.skinHeight);
      }

      free(Framesp[0].Vertsp);
      free(Skinsp);
      free(TexCoordsp);
      free(Trianglesp);
      free(Framesp);
      fclose(file);
}
 
bool display(int frame)
{
    if (objs_header == false)
    {
        for(int i = 0; i < Md21.numVertices; i++)
        {
            glVertex3f(Framesp[frame].Vertsp[i].vertex[0],
                       Framesp[frame].Vertsp[i].vertex[1],
                       Framesp[frame].Vertsp[i].vertex[2]);
        }
    }    
    if (objs_header == true)
    {
    glBegin(GL_TRIANGLES);
        for (int q = 0; q < object.poly_num; q++)
        {
            glTexCoord2f( object.texcoord[ object.triangle[q].a ].u,
                        object.texcoord[ object.triangle[q].a ].v);

            glVertex3f( object.vertex[ object.triangle[q].a ].x,
                        object.vertex[ object.triangle[q].a ].y,
                        object.vertex[ object.triangle[q].a ].z);

            glTexCoord2f( object.texcoord[ object.triangle[q].b ].u,
                        object.texcoord[ object.triangle[q].b ].v);

            glVertex3f( object.vertex[ object.triangle[q].b ].x,
                        object.vertex[ object.triangle[q].b ].y,
                        object.vertex[ object.triangle[q].b ].z);

            glTexCoord2f( object.texcoord[ object.triangle[q].c ].u,
                        object.texcoord[ object.triangle[q].c ].v);

            glVertex3f( object.vertex[ object.triangle[q].c ].x,
                        object.vertex[ object.triangle[q].c ].y,
                        object.vertex[ object.triangle[q].c ].z);
        }
    glEnd();
    }    
    
}    

void OBJECT::kill()
{
}    

